/*
PeRdr - PE file disassembler
Copyright (C) 2006 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#ifndef FILE_APIARGUMENTS_HPP
#define FILE_APIARGUMENTS_HPP

#include <string>
#include <vector>
#include <map>
#include "symbols.h"

typedef std::vector<std::string> TFnArgs;
typedef std::map<std::string, TFnArgs> TApiFn;

class ApiArguments
{
public:
  bool Populate();
  /** Return pointer to argument list given an API name
   * returns 0 if not found
   */
  const TFnArgs* find(const std::string&) const;
  const TFnArgs* find(vma_t) const;
  Symbols aliases;
private:
  bool Populate(const char*);
  TApiFn fn;
};

#endif //FILE_APIARGUMENTS_HPP
