/*
 * PeRdr - PE file disassembler
 * Copyright (C) 1999-2006 Frediano Ziglio
 * -----
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * -----
 *
 * INFORMATION
 *   www: http://freddy77.tripod.com/perdr/
 *     e-mail: freddy77@angelfire.com
 *     */
#ifndef FILE_APICACHE_H
#define FILE_APICACHE_H

#include <string>

class ApiCache
{
public:
  struct DllFunctions
  {
    const char *name;
    int count;
    const int * ords;
    const char * const * names;
  };
  /**
   * Return api name given dll and ordinal
   * return false if not found
   * change string passed if found
   */
  static bool GetFullApiName(std::string& out,const char* dll,int ordinal);
private:
  static const int numCachedDlls;
  static const DllFunctions cachedDlls[];
};

#endif // FILE_APICACHE_H

