/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#include "global.h"
#ifdef HAVE_HDRSTOP
#pragma hdrstop
#endif

#include <set>
#include <algorithm>
#include <string>
#include "registers.h"

using namespace std;

// costruisci la tabelle con tutti i dati
#define DEFINE_REG(size,type,name,string,complete,mask) \
 { reg_info::size, reg_info::type, string, complete, mask },
const reg_info regs[] =
{
#include "x86regs.h"
};
#undef DEFINE_REG
#define NUM_REG (sizeof(regs)/sizeof(regs[0]))

struct __find_reg: public unary_function<const reg_info&,bool>
{
  __find_reg(const char* _p):p(_p) {};
  bool operator()(const reg_info& info)
  { return strcmp(info.name,p) == 0; };
  const char* p;
};

reg_t find_reg(const char *reg)
{
  int n = find_if(regs,regs+NUM_REG,__find_reg(reg)) - regs;
  if (n == NUM_REG)
    return null_reg;
  return static_cast<reg_t>(n);
}

const reg_info* RegistryInfo::GetInfo(const char* name)
{
  const reg_info *p = find_if(regs,regs+NUM_REG,__find_reg(name));
  if ( p == (regs+NUM_REG) )
    return NULL;
  return p;
}

const reg_info* RegistryInfo::GetInfo(reg_t i)
{
  if ( unsigned(i) >= NUM_REG )
    return NULL;
  return &regs[i];
}

reg_t RegistryInfo::GetIndex(const char* name)
{
  return find_reg(name);
}

