/*
PeRdr - PE file disassembler
Copyright (C) 1999-2006 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#include "global.h"
#ifdef HAVE_HDRSTOP
#pragma hdrstop
#endif

#include "relocationinfo.h"

void RelocationInfos::AddRelocation(const Relocation& rel,vma_t address)
{
  _PRG_ASSERT(rel.GetType() == Relocation::relNone ||
    rel.GetType() == Relocation::relRelative);
  if ( rel.GetType() != Relocation::relNone )
    relocations.insert(address);
}

static const Relocation relRelative(Relocation::relRelative);

const Relocation* RelocationInfos::GetRelocation(vma_t address,unsigned bytes) const
{
  t_relocations::const_iterator i = relocations.lower_bound(address);
  if ( i == relocations.end() )
    return NULL;

  if ( *i == address && bytes == 4 ) // !!! constants !!!
    // la rilocazione e' ok!
    return &relRelative;
  else if ( address+bytes > *i )
    return &relError;
  return NULL;
}

const Relocation* RelocationInfos::GetRelocation(vma_t address) const
{
  // !!! memoriazzre ultimo byte per rilocazioni ?
  t_relocations::const_iterator i = relocations.lower_bound(address-3);
  if ( i == relocations.end() )
    return NULL;
  if ( *i == address)
    return &relRelative;
  if ( (address - *i) < 4 ) // !!! constants !!!
    return &relError;
  return NULL;
}

const Relocation RelocationInfos::relError(Relocation::relNone);

