/*
PeRdr - PE file disassembler
Copyright (C) 1999-2006 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#ifndef FILE_SIGNFILE_HPP
#define FILE_SIGNFILE_HPP

#include "utils/range.hpp"
#include "file.hpp"

class CSignFile:public CFile
{
public:
  CSignFile(const char* filename,const char* mode);
  char *ReadString(int delim=0) const;
  char *ReadStringFlag(unsigned flag) const;
  void RawRead(void *ptr,size_t size) const;
  const range_set<long>& GetRanges() { return ranges; };
private:
  typedef range_set<long> t_ranges;
  mutable t_ranges ranges;
};

#endif //FILE_SIGNFILE_HPP
